/**
 * LOG module
 * Logs trough the UART module with a printf-like interface
 * Log trace headers include the task handle, tick count, task name
 * Depends on the UART, PRINTF modules
 *
 * 20151113		1.0		Documentation updated
 * 20151013		0.9		Creation
 */

#ifndef __LOG_H_
#define __LOG_H_

#include "FreeRTOS.h"
#include "semphr.h"
#include "utils.h"
#include "uart.h"


/**Initialize the log module
 *
 * @param portNum	port to use
 *
 * @return			see Result
 */
Result LOG_init(UART_port  port);

/**Emit a log trace line
 * @param			same as standard printf()
 *
 * @return			see Result
 */
Result LOG_log(const char* format, ...);


#endif /* __LOG_H_ */
