#include "circularbuffer.h"

void CIRCULARBUFFER_init(CIRCULARBUFFER_data* cb, char* buffer, size_t size)
{
    cb->buffer = buffer;
    cb->end = cb->buffer + size;
    cb->head = cb->buffer;
    cb->tail = cb->buffer;
    cb->size = size;
    cb->count = 0;
}

Result CIRCULARBUFFER_pushBack(CIRCULARBUFFER_data* cb, char item)
{
    if(cb->count == cb->size)
    {
    	return Result_Failed;
    }
    *cb->head = item;
    cb->head++;
    if(cb->head == cb->end)
    {
        cb->head = cb->buffer;
	}
	cb->count++;
    return Result_OK;
}

Result CIRCULARBUFFER_popFront(CIRCULARBUFFER_data* cb, char* item)
{
    if(cb->count == 0)
    {
    	*item = 0;
    	return Result_Failed;
    }
    *item = *cb->tail;
    cb->tail++;
    if(cb->tail == cb->end)
    {
        cb->tail = cb->buffer;
    }
    cb->count--;
    return Result_OK;
}

Result CIRCULARBUFFER_clean(CIRCULARBUFFER_data* cb)
{
	cb->tail = cb->head;
	cb->count = 0;
    return Result_OK;
}

void CIRCULARBUFFER_toString(CIRCULARBUFFER_data* cb, char* buffer)
{
	char* it = cb->tail;
	uint32_t i = 0;
	for(i = 0 ; i < cb->count ; i++)
	{
		buffer[i] = *it;
		it++;
		if(it == cb->end)
		{
			it = cb->buffer;
		}
	}
	buffer[i] = 0;
}
