#include "test_framework.h"
#include "test_helpers.h"
#include "test_config.h"
#include "printf.h"
#include <stdio.h>


/* callback that computes key index from keypad's (a,b) axis */
static uint32_t testComputeIndexCallback(uint32_t a, uint32_t b, uint32_t countA, uint32_t countB)
{
	countA = countA; /* unused & irrelevant */
	return (a * countB) + b;
}

/* keypad configuration for many test that use the keypad */
const KEYPAD_cfg testKeypadCfg =
{
	testConfig_PortB, testConfig_PinStartKeypadA, testConfig_PinSizeKeypadA,
	testConfig_PortB, testConfig_PinStartKeypadB, testConfig_PinSizeKeypadB,
	3*4, "123456789*0#", ' ', testComputeIndexCallback
};

/* displays test instructions on the terminal. Meant for manual tests */
void showInstructions(char** instructions)
{
	char tmp[30];
	uint32_t i = 0;
	PRINTF_print(testConfig_loggerPort, "%s\r\n    TEST INSTRUCTIONS\r\n", makeAnsiColors(Color_Cyan, Color_Black, tmp));
	while(instructions[i])
	{
		PRINTF_print(testConfig_loggerPort, "    %s\r\n", instructions[i++]);
	}
	PRINTF_print(testConfig_loggerPort, "\r\n");
	PRINTF_print(testConfig_loggerPort, makeAnsiResetAttributes());
}
