#include "test_framework.h"
#include "test_helpers.h"
#include "test_config.h"
#include "keypad.h"
#include "log.h"
#include "printf.h"
#include "utils.h"
#include <assert.h>
#include <string.h>


/* Manual test for the KEYPAD module. See in-test instructions for details */
void manualTest_keypad(void* pvParameters)
{
	assert(pvParameters==NULL);
	char* instructions [] =
	{
		"Manual test for KEYPAD module.",
		"To finish it, enter the '1234' sequence.",
		"Press keypad keys and check that behavior is as expected.",
		"Keys will be printed out at as they are entered.",
		NULL
	};
	showInstructions(instructions);

	enum { exitStringSize = 4 };
	char exitString[exitStringSize] = "1234";
	int exitStringCount = 0;

	KEYPAD_init(&testKeypadCfg);
	while(exitStringCount < exitStringSize)
	{
		char keys[3*4] = { 0 };
		/*Result result =  */ KEYPAD_scan(&testKeypadCfg, keys);
		char key = KEYPAD_getKeypress(&testKeypadCfg, keys);
		if(key)
		{
			PRINTF_print(testConfig_loggerPort, "%c", key);
			exitStringCount = (key == exitString[exitStringCount]) ? exitStringCount+1 : 0;
			while(key) /* eat all keypresses until no key is pressed */
			{
				/*result = */ KEYPAD_scan(&testKeypadCfg, keys);
				key = KEYPAD_getKeypress(&testKeypadCfg, keys);
			}
		}
		vTaskDelay(msToTicks(100));
	}
}
