#include "printf.h"
#include "uart.h"
#include "parsing.h"
#include "test_framework.h"
#include "test_config.h"
#include <assert.h>
#include <string.h>


/**Sends a distinct (per UART) message to from UARTS.
 * Running this test helps in determining what UART is the terminal actually connected.
 */
void noTest_printfBroadcast(void* pvParameters)
{
	assert(pvParameters == NULL);
	UART_port port;
	for(port = 0; port < UART_portNum ; port++)
	{
		if(port == UART_port2) continue;
		if(port == (int)testConfig_loggerPort) continue;

		TEST_CheckResult(PRINTF_init(port));
		TEST_CheckResult(UART_init(port, 9600, UART_modeWithInterrupts));
	}

	uint32_t timeoutMs = 5000;
	uint32_t timeoutTicks = xTaskGetTickCount() + msToTicks(timeoutMs);
	while(xTaskGetTickCount() < timeoutTicks)
	{
		for(port = 0; port < UART_portNum ; port++)
		{
			if(port == UART_port2) continue;
			if(port == (int)testConfig_loggerPort) continue;

			PRINTF_print(port, "PRINTF_print from port_%d\r\n", port);
		}
		vTaskDelay(msToTicks(100));
	}

	for(port = 0 ; port < UART_portNum ; port++)
	{
		if(port == UART_port2) continue;
		if(port == (int)testConfig_loggerPort) continue;

		TEST_CheckResult(UART_deinit(port));
		TEST_CheckResult(PRINTF_deinit(port));
	}
}
